Loading...
Searching...
No Matches
gsm0502.h File Reference
GSM 05.02 / 3GPP TS 45.002
`#include <stdint.h>`
`#include <osmocom/gsm/protocol/gsm_04_08.h>`
`#include <osmocom/gsm/protocol/gsm_08_58.h>`

Go to the source code of this file.

## Macros

#define | GSM_TDMA_FN_DURATION_nS 4615384 /* in 1e−9 seconds (approx) */
#define | GSM_TDMA_FN_DURATION_uS 4615 /* in 1e-6 seconds (approx) */
#define | GSM_TDMA_SUPERFRAME (26 * 51)
#define | GSM_TDMA_HYPERFRAME (2048 * GSM_TDMA_SUPERFRAME)
#define | GSM_TDMA_FN_SUM(a, b)
| Return the sum of two specified TDMA frame numbers (summation).
#define | GSM_TDMA_FN_SUB(a, b)
| Return the difference of two specified TDMA frame numbers (subtraction).
#define | GSM_TDMA_FN_DIFF(a, b)
| Return the minimum difference of two specified TDMA frame numbers (distance).
#define | GSM_TDMA_FN_INC(fn)
| Increment the given TDMA frame number by 1 and return the result (like ++fn).
#define | GSM_TDMA_FN_DEC(fn)
| Decrement the given TDMA frame number by 1 and return the result (like –fn).
#define | GSM_NBITS_NB_GMSK_TAIL 3
#define | GSM_NBITS_NB_GMSK_PAYLOAD (2 * 58)
#define | GSM_NBITS_NB_GMSK_TRAIN_SEQ 26
#define | GSM_NBITS_NB_GMSK_BURST 148 /* without guard period */
#define | GSM_NBITS_NB_8PSK_TAIL (GSM_NBITS_NB_GMSK_TAIL * 3)
#define | GSM_NBITS_NB_8PSK_PAYLOAD (GSM_NBITS_NB_GMSK_PAYLOAD * 3)
#define | GSM_NBITS_NB_8PSK_TRAIN_SEQ (GSM_NBITS_NB_GMSK_TRAIN_SEQ * 3)
#define | GSM_NBITS_NB_8PSK_BURST (GSM_NBITS_NB_GMSK_BURST * 3)
#define | GSM_NBITS_SB_GMSK_TAIL GSM_NBITS_NB_GMSK_TAIL
#define | GSM_NBITS_SB_GMSK_PAYLOAD (2 * 39)
#define | GSM_NBITS_SB_GMSK_ETRAIN_SEQ 64
#define | GSM_NBITS_SB_GMSK_BURST GSM_NBITS_NB_GMSK_BURST
#define | GSM_NBITS_DB_GMSK_TAIL GSM_NBITS_NB_GMSK_TAIL
#define | GSM_NBITS_DB_GMSK_MIXED 142
#define | GSM_NBITS_DB_GMSK_BURST GSM_NBITS_NB_GMSK_BURST
#define | GSM_NBITS_AB_GMSK_ETAIL 8
#define | GSM_NBITS_AB_GMSK_SYNCH_SEQ 41
#define | GSM_NBITS_AB_GMSK_PAYLOAD 36
#define | GSM_NBITS_AB_GMSK_TAIL GSM_NBITS_NB_GMSK_TAIL
#define | GSM_NBITS_AB_GMSK_BURST GSM_NBITS_NB_GMSK_BURST

## Enumerations

enum | gsm0502_fn_remap_channel { FN_REMAP_TCH_F , FN_REMAP_TCH_H0 , FN_REMAP_TCH_H1 , FN_REMAP_FACCH_F , FN_REMAP_FACCH_H0 , FN_REMAP_FACCH_H1 , FN_REMAP_MAX }

## Functions

static int | gsm0502_fncmp (uint32_t fn1, uint32_t fn2)
| Compare the given TDMA FNs, taking the wrapping into account.
static unsigned int | gsm0502_get_n_pag_blocks (const struct gsm48_control_channel_descr *chan_desc)
static unsigned int | gsm0502_get_ccch_group (uint64_t imsi, unsigned int bs_cc_chans, unsigned int n_pag_blocks)
static unsigned int | gsm0502_get_paging_group (uint64_t imsi, unsigned int bs_cc_chans, int n_pag_blocks)
unsigned int | gsm0502_calc_paging_group (const struct gsm48_control_channel_descr *chan_desc, uint64_t imsi)
uint32_t | gsm0502_fn_remap (uint32_t fn, enum gsm0502_fn_remap_channel channel)
| Calculate the frame number of the beginning of a block.
uint16_t | gsm0502_hop_seq_gen (const struct gsm_time *t, uint8_t hsn, uint8_t maio, size_t n, const uint16_t *ma)
| Hopping sequence generation as per 3GPP TS 45.002, section 6.2.3.
int | gsm0502_fn2ccch_block (uint32_t fn)
| Calculate CCCH block number from the given TDMA frame number.